/*
 *  LaunchpadHelper.cpp
 *  Launchonme_terminal
 *
 *  Created by Johan Larsby on 12/4/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */
 #include <iostream>
#include <CoreMIDI/CoreMIDI.h>
#include "logic.h"
#include "LaunchpadHelper.h"


// from launchpad
MIDIPortRef    gOutPort = NULL;
MIDIEndpointRef  gDest = NULL;
MIDIEndpointRef    gOutPortH = NULL;
MIDIEndpointRef  gDestH = NULL;
MIDIPortRef inPort = NULL;
MIDIClientRef client = NULL;

char buf[256];
int rc;


bool helperRunning = true;



int delight=666;
int deslight=777;



void 
sendShortToLaunchpad( char midiStatusByte, char midiDataByte1, char midiDataByte2)
{
    OSStatus status;
    Byte buffer[256];
    MIDIPacketList *packetList = (MIDIPacketList *)buffer;
    MIDIPacket *packet = MIDIPacketListInit(packetList);
    Byte midiMessage[] = { (Byte)midiStatusByte, (Byte)midiDataByte1, (Byte)midiDataByte2 };
    packet = MIDIPacketListAdd(packetList, 
                               sizeof(buffer), 
                               packet, 
                               0, 
                               3,
                               midiMessage);
	
	
	status = MIDISend(gOutPort, gDest, packetList);
}


/*this is what comes from the launchpad */
void _handleMIDIMessageFromLaunchpad( int status, int data1,int  data2)
{
	handleMIDIMessageFromLaunchpad(status,data1,data2);
	
}
void _handleMIDIMessageFromHost( int status, int data1,int  data2)
{
	handleMIDIMessageFromHost(status,data1,data2);
}

//readin data from the launchpad
static void  MyReadProc(const MIDIPacketList *packetList, void *refCon, void *connRefCon)
{
	const MIDIPacket *packet = &packetList->packet[0];
	int uid = (int) refCon;
	
//	printf("%d   - ",uid); //666 is from the launchpad and 777 is from the host
	
	for (unsigned int i = 0; i < packetList->numPackets; i++) 
	{
	 	
		unsigned char status, data1, data2, index;
		
		index = 0;
		
		
		
		for (unsigned int j = 0; j < packet->length; j++) 
		{
			unsigned char midiByte = packet->data[j];
			
			switch (index)
			{
				case 0:
					if (midiByte & 0x80) 
					{
						status = midiByte;
						index = 1;
					}
					
					break;
					
				case 1:
					if (midiByte & 0x80) 
					{
						status = midiByte;
						index = 1;
					}
					else 
					{
						data1 = midiByte;
						index = 2;
					}
					
					break;
					
				case 2:
					if (midiByte & 0x80) 
					{
						if(uid==777)
						{
							_handleMIDIMessageFromHost( status, data1, data2);
							
						}
						else 
						{
							_handleMIDIMessageFromLaunchpad( status, data1, data2);
							
						}
						
						
						status = midiByte;
						index = 1;
					}
					else
					{
						data2 = midiByte;
						if(uid==777)
						{
							_handleMIDIMessageFromHost( status, data1, data2);
							
						}
						else 
						{
							_handleMIDIMessageFromLaunchpad( status, data1, data2);
							
						}					
						index = 0;
					}
					
					break;
			}
		}
		
		if (index != 0)
		{
			if(uid==777)
			{
				_handleMIDIMessageFromHost( status, data1, data2);
				
			}
			else 
			{
				_handleMIDIMessageFromLaunchpad( status, data1, data2);
				
			}
		}
		packet = MIDIPacketNext(packet);
	}
	
}


void setupFromLaunchpad()
{
	int i, n;
	CFStringRef pname, pmanuf, pmodel;
	char name[64], manuf[64], model[64];
	
	MIDIInputPortCreate(client, CFSTR("Input port"), MyReadProc, (void *)delight, &inPort);
	MIDIOutputPortCreate(client, CFSTR("Output port"), &gOutPort);
	
	
	
	n = MIDIGetNumberOfDevices();
	for (i = 0; i < n; ++i) 
	{
		MIDIDeviceRef dev = MIDIGetDevice(i);
		
		MIDIObjectGetStringProperty(dev, kMIDIPropertyName, &pname);
		MIDIObjectGetStringProperty(dev, kMIDIPropertyManufacturer, &pmanuf);
		MIDIObjectGetStringProperty(dev, kMIDIPropertyModel, &pmodel);
		
		CFStringGetCString(pname, name, sizeof(name), 0);
		CFStringGetCString(pmanuf, manuf, sizeof(manuf), 0);
		CFStringGetCString(pmodel, model, sizeof(model), 0);
		CFRelease(pname);
		CFRelease(pmanuf);
		CFRelease(pmodel);
		
		printf("name=%s, manuf=%s, model=%s\n", name, manuf, model);
		
	/*	if ( strcmp(model,"Launchpad")==0 ) 
		{
			printf("Launchpad FOUNDED\n");
			
			MIDIEndpointRef src = MIDIGetSource(i);
			MIDIPortConnectSource(inPort, src, NULL);
			gDest = MIDIGetDestination(0);
			if(gDest != NULL)
			{
				MIDIObjectGetStringProperty(gDest, kMIDIPropertyName, &pname);
				CFStringGetCString(pname, name, sizeof(name), 0);
				CFRelease(pname);
				printf("Launchpad on %s\n", name);
			}

		}
	 */
	}
	
	
	// open connections from all sources
	n = MIDIGetNumberOfSources();
	printf("%d sources\n", n);
	for (i = 0; i < n; ++i) 
	{
		MIDIEndpointRef src = MIDIGetSource(i);
		MIDIPortConnectSource(inPort, src, NULL);
	}
	
	// find the first destination
	n = MIDIGetNumberOfDestinations();
	if (n > 0)
		gDest = MIDIGetDestination(0);
	
	if (gDest != NULL) 
	{
		MIDIObjectGetStringProperty(gDest, kMIDIPropertyName, &pname);
		CFStringGetCString(pname, name, sizeof(name), 0);
		CFRelease(pname);
		printf("Launchpad on %s\n", name);
	} 
	else 
	{
		printf("No Launchpad found\n");
	}
	

	
}

void sendShortToHost( char midiStatusByte, char midiDataByte1, char midiDataByte2)
{
    OSStatus status;
    Byte buffer[256];
    MIDIPacketList *packetList = (MIDIPacketList *)buffer;
    MIDIPacket *packet = MIDIPacketListInit(packetList);
    Byte midiMessage[] = { (Byte)midiStatusByte, (Byte)midiDataByte1, (Byte)midiDataByte2 };
    packet = MIDIPacketListAdd(packetList, 
                               sizeof(buffer), 
                               packet, 
                               0, // mach_absolute_time()
                               3,
                               midiMessage);
	
    status = MIDIReceived(gDestH, packetList);
}


void setupFromHost()
{
	CFStringRef sourceNameAsCFString = CFStringCreateWithCString(NULL, "Launchpad Helper Input", kCFStringEncodingMacRoman);
    OSStatus status = MIDISourceCreate(client,
                                       sourceNameAsCFString,
                                       &gDestH);
    if (status == 0) 
	{
        CFStringRef clientName;
        MIDIObjectGetStringProperty(client, kMIDIPropertyName, &clientName);
		
        MIDIObjectSetStringProperty(gDestH, 
                                    kMIDIPropertyDriverOwner,
                                    clientName);
	}                         
	
	
	CFStringRef destinationNameAsCFString = CFStringCreateWithCString(NULL, "Launchpad Helper Output", kCFStringEncodingMacRoman);
	status = MIDIDestinationCreate(client,
								   destinationNameAsCFString,
								   (MIDIReadProc)MyReadProc,
								   (void *)deslight,
								   &gOutPortH);
    if (status == 0) 
	{
        CFStringRef clientName;
        MIDIObjectGetStringProperty(gOutPortH,kMIDIPropertyName, &clientName);
        MIDIObjectSetStringProperty(gOutPortH, kMIDIPropertyDriverOwner, clientName);
    }
}


void setupCommunications()
{
	MIDIClientCreate(CFSTR("LauncherHelper"), NULL, NULL, &client);
	setupFromLaunchpad();
	setupFromHost();
}

// The thread entry point routine.
void* PosixThreadMainRoutine2(void* data)
{
	loop2();
		
    return NULL;
}

// The thread entry point routine.
void* PosixThreadMainRoutine(void* data)
{
	
	loop1();
	    return NULL;
}

void LaunchThreads()
{
    pthread_attr_t  attr;
    pthread_t       posixThreadID;
	
    assert(!pthread_attr_init(&attr));
    assert(!pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED));
	
    int     threadError = pthread_create(&posixThreadID, &attr, &PosixThreadMainRoutine, NULL);
	
    assert(!pthread_attr_destroy(&attr));
    if (threadError != 0)
    {
		// Report an error.
    }
	
	// Create the thread using POSIX routines.
    pthread_attr_t  attr2;
    pthread_t       posixThreadID2;
	
    assert(!pthread_attr_init(&attr2));
    assert(!pthread_attr_setdetachstate(&attr2, PTHREAD_CREATE_DETACHED));
	
    int     threadError2 = pthread_create(&posixThreadID2, &attr2, &PosixThreadMainRoutine2, NULL);
	
    assert(!pthread_attr_destroy(&attr2));
    if (threadError2 != 0)
    {
		// Report an error.
    }
	
}
void stopHelper()
{
	helperRunning=false;
}
//-----------------------------

void resetLaunchPad()
{
	sendShortToLaunchpad(176, 0, 0);
}


void enableBlink()
{
	sendShortToLaunchpad(176, 0, 40);
}

void setButton(int x,int y,int col)
{
	sendShortToLaunchpad(144,66,127);
}




int main (int argc, char * const argv[])
{
  	int tem;
	
	setupCommunications(); //starting MIDI connections to Launchpad and the created port
	
	setup();
	
	tem = fcntl(0, F_GETFL, 0);
	fcntl (0, F_SETFL, (tem | O_NDELAY));
	
	LaunchThreads();
 	
	while (helperRunning) 
	{
		
	}
	fcntl(0, F_SETFL, tem);
	
	printf("disposing\n");
	
	{
		int n,i;
		
		
		// open connections from all sources
		n = MIDIGetNumberOfSources();
		for (i = 0; i < n; ++i) 
		{
			MIDIEndpointRef src = MIDIGetSource(i);
			MIDIPortDisconnectSource(inPort, src);
		}
	}
	
	
	MIDIEndpointDispose(gDest);
	MIDIEndpointDispose(gOutPortH);
	MIDIEndpointDispose(gDestH);
	
	
	MIDIPortDispose(gOutPort);
	MIDIPortDispose(inPort);

	MIDIClientDispose(client);
	
	
	
	printf("disposing ended \n");
	
 	
    return 0;
}

